//
// Copyright (C) 2016 OpenSim Ltd.
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public License
// along with this program; if not, see http://www.gnu.org/licenses/.
//

#include "inet/linklayer/ieee80211/mac/framesequence/PcfFs.h"
#include "inet/linklayer/ieee80211/mac/framesequence/PrimitiveFrameSequences.h"

namespace inet {
namespace ieee80211 {

PcfFs::PcfFs() :
    // Excerpt from G.2 Basic sequences (p. 2309)
    // frame-sequence =
    //   ( PS-Poll ACK ) |
    //   ( [ Beacon + DTIM ] {cf-sequence} [ CF-End [+ CF-Ack ] ] )
    AlternativesFs({new SequentialFs({}), // TODO: poll
                    new SequentialFs({})}, // TODO: beacon
                   ALTERNATIVESFS_SELECTOR(selectPcfSequence))
{
}

int PcfFs::selectPcfSequence(AlternativesFs *frameSequence, FrameSequenceContext *context)
{
    return 0;
}

} // namespace ieee80211
} // namespace inet

